/* GF Matrix-Matrix Multiply on the CPU

This file holds a routine for Matrix-Matrix Multiply over GF256.
The routine runs on the CPU and is not well tuned 
   
DO NOT MODIFY THIS FILE!!!

*/
   
#include <stdio.h>
#include <stdlib.h>

#define GFSIZE 256
   
typedef unsigned char UINT8;   

int gfmmm_cpu(UINT8 *mul_table, UINT8 *A, UINT8 *B, UINT8 *C, int n){
  int i, j, k;
  UINT8 tmp;
  
  for (i = 0; i < n; i++){ /* Loop over rows in result matrix C */
    for (j = 0; j < n; j++){ /* Loop over columns in result matrix C */
      tmp = 0; /* Reset rolling sum */
      for (k = 0; k < n; k++){ /* Loop over row in A and column in B */
        tmp ^= mul_table[A[i*n + k]*GFSIZE + B[k*n + j]]; /* Sum the partial products */
      }
      C[i*n + j] = tmp; /* Store result in C */
    }
  }
  
  return 0;
}
